﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Imaging;

namespace howto_tile_string
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ShowFont();
            DrawText();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            DrawText();
        }

        private void ShowFont()
        {
            lblFont.Text =
                fdFont.Font.Size.ToString() + " pt " +
                fdFont.Font.Name;
        }

        private void DrawText()
        {
            int width = int.Parse(txtWidth.Text);
            int height = int.Parse(txtHeight.Text);

            Bitmap bm = new Bitmap(width, height);
            using (Graphics gr = Graphics.FromImage(bm))
            {
                gr.Clear(picBackground.BackColor);

                using (Brush brush = new SolidBrush(picForeground.BackColor))
                {
                    string text = txtString.Text;
                    SizeF size = gr.MeasureString(text, fdFont.Font);
                    for (float y = 0; y < bm.Height; y += size.Height * 0.8f)
                    {
                        float x = y;
                        while (x > 0) x -= size.Width;

                        while (x <= bm.Width)
                        {
                            gr.DrawString(text, fdFont.Font, brush, x, y);
                            x += size.Width;
                        }
                    }
                }

                bm.Save("Result.png", ImageFormat.Png);
                picImage.Image = bm;
            }
        }

        private void picBackground_Click(object sender, EventArgs e)
        {
            cdColor.Color = picBackground.BackColor;
            if (cdColor.ShowDialog() == DialogResult.OK)
                picBackground.BackColor = cdColor.Color;
        }

        private void picForeground_Click(object sender, EventArgs e)
        {
            cdColor.Color = picForeground.BackColor;
            if (cdColor.ShowDialog() == DialogResult.OK)
                picForeground.BackColor = cdColor.Color;
        }

        private void lblFont_Click(object sender, EventArgs e)
        {
            if (fdFont.ShowDialog() == DialogResult.OK)
                ShowFont();
        }
    }
}
